<?php
/**
 * Created by PhpStorm.
 * User: tim
 * Date: 12.10.16
 * Time: 13:39
 */
class App_Payanyway extends Controller
{
	function indexAction(array $params)
	{
		die();
	}

	function resultAction(array $params)
	{
	
		$secret = $this->model->stuff->get()->payanyway_secret;

		// чтение параметров
		$mnt_id = $_REQUEST["MNT_ID"];
		$mnt_transaction_id = $id = $_REQUEST["MNT_TRANSACTION_ID"];
		$mnt_operation_id = $_REQUEST["MNT_OPERATION_ID"];
		$mnt_amount = $_REQUEST["MNT_AMOUNT"];
		$mnt_currency_code = $_REQUEST["MNT_CURRENCY_CODE"];
		$mnt_subscriber_id = $_REQUEST["MNT_SUBSCRIBER_ID"];
		$mnt_test_mode = $_REQUEST["MNT_TEST_MODE"];
		$mnt_signature = strtoupper($_REQUEST["MNT_SIGNATURE"]);

		$signature = strtoupper(md5(
			$mnt_id.$mnt_transaction_id.$mnt_operation_id.$mnt_amount.$mnt_currency_code.$mnt_subscriber_id.$mnt_test_mode.$secret
		));
		
		// проверка корректности подписи
		if ($mnt_signature != $signature)
		{
			echo "FAIL";
			die();
		}
		// отправляем письмо об оплате
		require_once DIR_LIB.'/phpmailer/class.phpmailer.php';

		$this->var = $this->model->page->get('order');
		$mail = new PHPMailer();
		$mail->From     = 'no-reply@'.$_SERVER['HTTP_HOST'];
		$mail->FromName = $_SERVER['HTTP_HOST'];
		$mail->Host     = $_SERVER['HTTP_HOST'];
		if (YANDEX_SMTP_LOGIN && YANDEX_SMTP_PASS)
		{
			$mail->From     = YANDEX_SMTP_LOGIN;//$data->email;
			$mail->IsSMTP(); // enable SMTP
			$mail->SMTPAuth = true;  // authentication enabled
			$mail->Host = 'smtp.yandex.ru';
			$mail->Port = 25;
			$mail->Username = YANDEX_SMTP_LOGIN;
			$mail->Password = YANDEX_SMTP_PASS;
		}
		else
		{
			$mail->Mailer   = "mail";
		}
		$mail->Body    = nl2br("Заказ #$id оплачен на сумму $mnt_amount в системе PayAnyWay");
		$mail->AltBody = strip_tags(str_replace("<br/>", "\n", $mail->Body));
		$mail->Subject = 'Заказ оплачен #'.$id;
		$emails = array_map('trim',explode(',',$this->var->email));
		foreach ($emails as $email)
			$mail->AddAddress($email);

		$sent = $mail->Send();
		/**
		 * Сохраняем статус заказа
		 */
		$this->model->order->edit(array(
			'status' => "Оплачен"
		),$id);
		// признак успешно проведенной операции
		echo "SUCCESS";
		die();
	}
}
